<script>
import axios from '../axios'

export default {
    props: {
        selectedItem: {
            type: Object,
            default: ''
        },
        action: {
            type: Number,
            default: 1
        }
    },
    data() {
        return {
            data: [],
            orders: [],
            loading: true,

            user: localStorage.getItem("user") ? JSON.parse(localStorage.user) : null,
            step: this.$route.params.tab,
            type: this.$route.params.type,

            isEdit: false,
            hasError: {
                editProfile: null
            }
        }
    },
    mounted() {
        // this.getFavourites();
    },
    methods: {
        selectItem(item) {
            this.$emit('selectedItem', item);
            this.$emit('action', 2);
        },
        pay(price, item) {
            axios.post('/api/payment/buy', {
                price: price,
                item: item,
            }).then(({data}) => {
                this.getData();
                window.open(data)
            })
        },
        getFavourites() {
            axios.get('/api/favourite/get', {
                params: {
                    userId: this.user.id,
                    tab: this.type
                }
            }).then(data => {
                this.data = data.data.data;
            }).catch(error => {
                this.hasError = error;
            })
        },
        addToFavourite(item) {
            axios.post('/api/favourite/create', {
                userId: this.user.id,
                tab: item.tab,
                id_favourite: item.id_favourite,
                item: item.item,
            }).then(({data}) => {
                this.data.push({
                    tab: item.tab,
                    id_favourite: item.id_favourite,
                });

                item.item.favourite = true;
            }).catch(error => {
                this.hasError = error;
            })
        },
        removeFavourite(item) {
            axios.delete('/api/favourite/remove', {
                params: {
                    userId: this.user.id,
                    tab: item.tab,
                    id_favourite: item.id_favourite,
                }
            }).then(({data}) => {
                item.item.favourite = false;
            }).catch(error => {
                this.hasError = error;
            })
        },
        openLink(link) {
            window.open(link)
        },
        formatPrice(price) {
            return Math.round(fx(price).from("RUB").to("EUR"))
        },
        myOrders() {

        },
    },
    watch: {
        '$route.params': {
            handler(params) {
                this.type = params.type || 'all';
                this.getFavourites();
            },
            immediate: true
        }
    }
}
</script>

<template>
    <div class="orders">
        <div class="tab-content" id="myTabContent">
            <div class="tab-pane fade show active" v-if="type === 'all'" id="all" role="tabpanel" aria-labelledby="all-tab">
                <div class="orders__list favourites__list">
                    <template v-for="item in data">
                        <div class="orders__item hotels" v-if="item.tab === 'hotel'">
                            <div class="hotels__info">
                                <div class="hotels__top">
                                    <div class="hotels__top--image" v-if="JSON.parse(item.item).photos[0].thumb">
                                        <img :src="JSON.parse(item.item).photos[0].thumb" alt="room-image">
                                    </div>
                                    <div class="favourite">
                                        <div @click="removeFavourite({
                                            tab: 'hotel',
                                            id_favourite: item.id,
                                            item: item,
                                        })" class="favourite">
                                            <img src="../img/icons/favourite-check.svg" alt="favourite">
                                        </div>
                                    </div>
                                </div>
                                <div class="name">
                                    {{ JSON.parse(item.item).name }}
                                    <div class="stars">
                                        <img src="../img/icons/star-black.svg" alt="star">
                                        <span>{{ JSON.parse(item.item).stars }}</span>
                                    </div>
                                </div>
                                <div class="hotels__bottom">
                                    <div class="orders__rooms--button">
                                        <button class="btn">More detailed</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="orders__item flights" v-if="item.tab === 'flight'">
                            <div class="flights__info">
                                <div class="flights__top">
                                    <div class="flights__top--image">
                                        <img src="../img/images/country-image.png" alt="country-image">
                                    </div>
                                    <div class="favourite">
                                        <img src="../img/icons/favourite.svg" alt="favourite">
                                    </div>
                                </div>
                                <div class="name">
                                    {{ JSON.parse(item.item).depAirport.title }} -
                                    {{ JSON.parse(item.item).arriveAirport.title }}
                                    <div class="hours">
                                        {{ JSON.parse(item.item).duration.flight.hour }} h,
                                        {{ JSON.parse(item.item).duration.flight.minute }} min
                                    </div>
                                </div>
                                <div class="fly">
                                    <div class="fly__item">
                                        <div class="fly__item--img">
                                            <img src="../img/images/airlines.png" alt="airlines">
                                        </div>
                                        <div class="fly__item--info">
                                            <span>{{
                                                    JSON.parse(item.item).depTime
                                                }} - {{ JSON.parse(item.item).arriveTime }}</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="flights__bottom">
                                    <div class="flights__info--date">
                                        {{ JSON.parse(item.item).arriveDate }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </template>
                </div>
            </div>
            <div class="tab-pane fade" id="flights" v-if="type === 'flights'" role="tabpanel" aria-labelledby="flights-tab">
                <div class="orders__list favourites__list">
                    <template v-for="item in data">
                        <div class="orders__item flights" v-if="item.tab === 'flight'">
                            <div class="flights__info">
                                <div class="flights__top">
                                    <div class="flights__top--image">
                                        <img src="../img/images/country-image.png" alt="country-image">
                                    </div>
                                    <div class="favourite">
                                        <img src="../img/icons/favourite.svg" alt="favourite">
                                    </div>
                                </div>
                                <div class="name">
                                    {{ JSON.parse(item.item).depAirport.title }} -
                                    {{ JSON.parse(item.item).arriveAirport.title }}
                                    <div class="hours">
                                        {{ JSON.parse(item.item).duration.flight.hour }} h,
                                        {{ JSON.parse(item.item).duration.flight.minute }} min
                                    </div>
                                </div>
                                <div class="fly">
                                    <div class="fly__item">
                                        <div class="fly__item--img">
                                            <img src="../img/images/airlines.png" alt="airlines">
                                        </div>
                                        <div class="fly__item--info">
                                            <span>{{
                                                    JSON.parse(item.item).depTime
                                                }} - {{ JSON.parse(item.item).arriveTime }}</span>
                                        </div>
                                    </div>
                                </div>
                                <div class="flights__bottom">
                                    <div class="flights__info--date">
                                        {{ JSON.parse(item.item).arriveDate }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </template>
                </div>
            </div>
            <div class="tab-pane fade" id="hotels" v-if="type === 'hotels'" role="tabpanel" aria-labelledby="hotels-tab">
                <div class="orders__list favourites__list">
                    <template v-for="item in data">
                        {{item.tab === 'hotel'}}
                        <div class="orders__item hotels" v-if="item.tab === 'hotel'">
                            <div class="hotels__info">
                                <div class="hotels__top">
                                    <div class="hotels__top--image" v-if="JSON.parse(item.item).photos[0].thumb">
                                        <img :src="JSON.parse(item.item).photos[0].thumb" alt="room-image">
                                    </div>
                                    <div class="favourite">
                                        <div @click="removeFavourite({
                                tab: 'hotel',
                                id_favourite: item.id,
                                item: item,
                            })" class="favourite">
                                            <img src="../img/icons/favourite-check.svg" alt="favourite">
                                        </div>
                                    </div>
                                </div>
                                <div class="name">
                                    {{ JSON.parse(item.item).name }}
                                    <div class="stars">
                                        <img src="../img/icons/star-black.svg" alt="star">
                                        <span>{{ JSON.parse(item.item).stars }}</span>
                                    </div>
                                </div>
                                <div class="hotels__bottom">
                                    <div class="orders__rooms--button">
                                        <button class="btn">More detailed</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </template>
                </div>
            </div>
        </div>
    </div>
</template>

<style scoped>

</style>
